#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string>
#include <vector>
#include <sstream>

#include "Environment.h"
#include "JobSubmission.h"
#include "MdsQuery.h"
#include "CertInfo.h"
#define __UI_LIBRARY__ // Hack warning...
#include "../grid-manager/ui_downloader.h"
#include "../grid-manager/ui_uploader.h"

#include "wrappers.h"


using namespace std;


/* Giis.h */
int GetGiis (const vector <string> giisurls,
             vector <Giis> & giislist) {

	return GetGiises(giisurls, giislist);
}


/* MdsQuery.h */
vector<Cluster> GetClusters (vector <Giis> giislist,
                             const string usersn,
                             bool anonymous,
                             int debug,
                             int timeout) {

	return FindClusters(giislist, usersn, anonymous, timeout, debug);
}

void GetClusterInfo (vector <Cluster> & clusterlist,
                     int filter,
                     const string usersn,
                     bool anonymous,
                     int debug,
                     int timeout) {
  
	FindClusterInfo(clusterlist, (Mds::Filter) filter, usersn, anonymous,
	                timeout, debug);
}


/* Wrapper for job submission through ui upload */
string ui_upload_submit_job(string resource, string rsl, vector<string> filenames,
                            int debug, int timeout) {
	char* jobid;

	int result = ui_uploader(resource.c_str(), rsl.c_str(), &jobid, resource.c_str(),
	                         RSL_ACTION_REQUEST, filenames, debug, timeout);
	if (result == 0) {
		return string(jobid);
	}
	else {
		return string("");
	}
}

/* Wrapper for job cancelation through ui upload */
int ui_upload_cancel_job(string resource, string short_jobid,
						 int debug, int timeout) {

	char *shortjobid = strdup(short_jobid.c_str());
	vector <string> filenames;

	int result = ui_uploader(resource.c_str(), NULL, &shortjobid, NULL,
	                         RSL_ACTION_CLEAN, filenames, debug, timeout);
	return result;
}

/* Wrapper for job clean up through ui upload */
int ui_upload_clean_job(string resource, string short_jobid,
                        int debug, int timeout) {

	char *shortjobid = strdup(short_jobid.c_str());
	vector <string> filenames;

	int result = ui_uploader(resource.c_str(), NULL, &shortjobid, NULL,
	                         RSL_ACTION_CLEAN, filenames, debug, timeout);
	return result;
}

/* Wrapper for proxy renewal through ui upload */
int ui_upload_renew_proxy(string resource, string short_jobid,
                          int debug, int timeout) {

	char *shortjobid = strdup(short_jobid.c_str());
	vector <string> filenames;

    int result = ui_uploader (resource.c_str(), NULL, &shortjobid, NULL,
	                          RSL_ACTION_RENEW, filenames, debug, timeout);
	return result;
}

/* Wrapper for ../grid-manager/ui_downloader.h */
int ui_download(string url, bool recursive, string path, vector<string> filenames, 
	       bool download_files, bool remove_files, int debug, int timeout) {

	return ui_downloader(url.c_str(), recursive, path.c_str(), filenames,
	                     download_files, remove_files, debug, timeout);

}



